/**
 * 
 */
var mX=0,mY=0;

var statements=[];
var divHoveringIndex=-1;
var divSrcIndex=-1;
var divDestinationIndex=-1;
var xOffset=0;
var yOffset=0;
var slotHeight=0;
var originalStatementLeft=0;
var originalStatementTop=0;
var entryID=0;
var explanationTitle="";

var effectRunning=false;

function initialise(){
    var leftBorder=10;
    showAppTitle();
    initialiseEvents();
    showPrompt();

    codeLeftBorder=$(document).width()/2+verticalBorder;
    codeTopBorder=$(document).height()/2;
    listLeft=leftBorder;
    listTop=$("#mainArea").position().top;
    defineMovablesArray();
    generateNewExpression();
    placeDIVs();
    initialiseEvents();
}

function initialiseEvents(){
    // touch events
    $("#showInfo").on("touchend",function(evt){
        $("#showInfo").trigger("click");
    });

    $("#list0").on("click tap touchstart touchend",function(evt){
        $(".itemToExplain").removeClass("itemToExplain");
        if(evt.target.id=="list0"){
            $("#list1").hide(animationRate);
        }
        else{
            handleTappedList(evt.target.id);
        }
        showListPrompt();
        evt.stopImmediatePropagation();
    });

    $("#assignmentToCheck0").on("touchend",function(evt){
        evt.preventDefault();
        evt.stopImmediatePropagation();
        $(".itemToExplain").removeClass("itemToExplain");

        $("#list"+wrongListIndex).css({
            "background-color":"#ffffff"
        });
        $("#list"+correctListIndex).css({
            "background-color":"#ffffff"
        });
        divSrcIndex=0;
        $("#"+statements[divSrcIndex].htmlID).addClass("tapped");
    });

    $("#btnCheckAnswer").on("click tap touchstart",function(evt){
        //evt.preventDefault();
        evt.stopImmediatePropagation();
        var userAnswer=$("#userAnswer").val();
        if(userAnswer=="") userAnswer="0";
        var originalRslt=$("#assignmentToCategorise").attr("data-result");
        var newClass="categorisationOk";
        explanationTitle="Ορθή αποτίμηση";
        if(userAnswer!=originalRslt){
            newClass="categorisationError";
            explanationTitle="Λανθασμένη αποτίμηση";
        }
        var itemToAdd=$("#assignmentToCategorise").html()+" = "+userAnswer;
        var explanation=$("#assignmentToCategorise").attr("data-explanation");
        var htmlToAdd="<code class='"+newClass+"' id='entry"+entryID+"' data-explTitle='"+explanationTitle+"' data-explanation='"+explanation+"'>"+itemToAdd+"</code><br>";
        var currentList=$("#list0").html();
        $("#list0").html(htmlToAdd+currentList);
        var scoreToShow=calculateScore(0);
        $("#score0").html(scoreToShow);
        generateNewExpression();
        showListPrompt();
    });
    
    $("#btnRefresh").on("click tap touchstart",function(evt){
        //evt.preventDefault();
        evt.stopImmediatePropagation();
        generateNewExpression();
    });
}

function handleTappedList(targetID){
    $("#"+targetID).addClass("itemToExplain");
    var param=$("#"+targetID).attr("data-explanation");
    $("#list1").show(animationRate);
    showExplanation(param);
}

function calculateScore(selectedList){
    var correctEntries=$("#list"+selectedList+" .categorisationOk").length;
    var totalEntries=correctEntries+$("#list"+selectedList+" .categorisationError").length;
    var percentage=parseInt(1000*correctEntries/totalEntries)/10;
    return ": "+correctEntries+"/"+totalEntries+" ("+percentage+"%)";
}

function showListPrompt(){
    var correctEntries=$("#list0 .categorisationOk").length;
    var totalEntries=correctEntries+$("#list0 .categorisationError").length;
    if($(".itemToExplain").length>0){
        $("#explain").html($(".itemToExplain").attr("data-explTitle"));
    }
    else if(totalEntries){
        $("#explain").html("Επιλέξτε μια καταχώρηση από τη λίστα για επεξήγηση του αποτελέσματος.");
    }
}

function showExplanation(explanation){
    $("#list1").html("<code>"+explanation+"</code>");
}

function defineMovablesArray(){
    var page=0,col=0,row=0;
    $.each($(".movableDIV"),function(){
        var height=parseInt($(this).outerHeight());
        slotHeight=Math.max(slotHeight,height);
    });
    var i=0;
    $.each($(".movableDIV"),function(){
        var htmlID=$(this).attr("id");
        originalStatementLeft=($(document).width()-$("#assignmentToCheck0").width())/2;
        originalStatementTop=$("#promptArea").position().top+$("#promptArea").height()+verticalBorder;
        var width=$("#assignmentToCheck0").width();
        var newStatement=new statement(htmlID,codeLeftBorder,codeTopBorder,originalStatementLeft,originalStatementTop,row,col,width,slotHeight,page,animationRate);
        statements.push(newStatement);
        row++;
        i++;
    });
    placeDIVs();
}

function generateNewExpression(){
    entryID++;
    var newValue="";
    var explanation="";
    currentValue=integerValue;
    newValue=generateArithmeticExpression(100,1,noOfArithmeticOperators,noOfIntegerFunctions);
    progressiveExpression=[];
    var result=stringExpressionValue(newValue,[],[],"","",true);
    progressiveExpression.push(result);
    explanation=getProgressiveExpression();
    var promptSwitch=result!=parseInt(result);
    showPrompt(promptSwitch);
    $("#assignmentToCategorise").html(newValue);
    $("#assignmentToCategorise").attr("data-result",result);
    $("#assignmentToCategorise").attr("data-explanation",explanation);
    $("#userAnswer").val(0);
    generatorCounter++;
    if(generatorCounter % 15 == 0){
        currentNoOfOperands=Math.min(currentNoOfOperands+1,maxNoOfOperands);
    }
}

function generateArithmeticExpression(factor1,factor2,permittedOperators,permittedFunctions){
    var operatorSelector=-1;
    var previousOperatorSelector=-1;
    var selectedOperator="";
    var operatorsToExclude=[];
    var excludingOperator=false;

    var functionSelector=-1;
    var selectedFunction="";
    var newValue="";
    
    var multiplicity=parseInt(Math.random()*(currentNoOfOperands-minNoOfOperands))+minNoOfOperands;//το πολύ maxNoOfOperands ορίσματα
    var newNumber=0;
    var includeFunction=false;
    var includeParenthesis=false;
    var parenthesisOpenPos=-1;
    var parenthesisClosePos=-1;
    if(multiplicity>4){
        includeParenthesis=Math.random()<1.4;
        if(includeParenthesis){
            parenthesisOpenPos=parseInt(Math.random()*3);
            var attempts=0;
            do{
                attempts++;
                parenthesisClosePos=parseInt(Math.random()*(multiplicity-parenthesisOpenPos)+parenthesisOpenPos);
            }while(attempts<80 && (parenthesisClosePos-parenthesisOpenPos<2 || parenthesisClosePos==multiplicity-1));
        }
    }
    for(var i=0;i<multiplicity;i++){
        if(i==parenthesisOpenPos){
            if(selectedOperator==" ^ "){
                parenthesisClosePos=-1;
            }
            else{
                newValue+="(";
            }
        }
        includeFunction=Math.random()<0.1;//10% πιθανότητα να χρησιμοποιηθεί συνάρτηση
        if(includeFunction){
            functionSelector=parseInt(Math.random()*permittedFunctions);
            selectedFunction=functions[functionSelector];
            newValue+=selectedFunction+"(";
        }
        /*else{//στο υπόλοιπο 90% χρησιμοποιείται παρένθεση με ...
            includeParenthesis=Math.random()<0.4;//...πιθανότητα 40%
            if(includeParenthesis){
                newValue+="(";
            }
        }*/

        if(selectedOperator==" ^ "){
            newNumber=2;
        }
        else if(selectedOperator==" * " || selectedOperator==" / " || selectedOperator==" div " || selectedOperator==" mod "){
            newNumber=parseInt(Math.random()*8+2);//αποκλεισμός της τιμής 1 ως δεύτερος όρος πολλαπλασιασμού ή διαίρεσης
        }
        else{
            newNumber=parseInt(Math.random()*9+1);
        }
        if(selectedFunction=="Τ_Ρ"){
            newNumber=Math.pow(Math.abs(newNumber),2);
        }
        else if(selectedFunction=="Α_Τ"){
            newNumber=-Math.abs(newNumber);
        }
        else if(selectedFunction=="Α_Μ"){
            newNumber=parseInt(Math.random()*100+1)/10+1;
        }

        newValue+=newNumber;
        if(includeFunction){
            newValue+=")";
            selectedFunction="";
        }
        if(i==parenthesisClosePos){
            newValue+=")";
        }
        if(i<multiplicity-1){
            do{//παραγωγή αριθμητικού τελεστή
                operatorSelector=parseInt(Math.random()*permittedOperators);
                selectedOperator=arithmeticOperators[operatorSelector];
                excludingOperator=false;
                var j=0;
                while(j<operatorsToExclude.length && !excludingOperator){
                    if(selectedOperator==operatorsToExclude[j]){
                        excludingOperator=true;
                    }
                    else{
                        j++;
                    }
                }
            }while(excludingOperator || operatorSelector==previousOperatorSelector);
            previousOperatorSelector=operatorSelector;
            newValue+=selectedOperator;
            if(selectedOperator==" / "){
                operatorsToExclude=[" div "," mod "];
            }
            else if(selectedOperator==" div " || selectedOperator==" mod "){
                operatorsToExclude=[" / "];
            }
        }
    }
    return newValue;
}

function placeDIVs(){
    $("#expressionValuePairs").css({
        left:listLeft,
        top:listTop
    });
    $("#expressionValuePairs").width($(document).width()-2*listLeft);
    $("#list0").width($("#expressionValuePairs").innerWidth()-2*listLeft);
    $("#list1").width($("#expressionValuePairs").innerWidth()-2*listLeft);
    showStatements();
    $("#controls").css({
        left:($(document).width()-$("#controls").width())/2,
        top:listTop-50
    });
    $("#userAnswer").width(200);
}

function showStatements(){
    for( var i=0;i<statements.length;i++){
        $("#assignmentToCheck"+i).show();
        statements[i].move(originalStatementLeft,originalStatementTop);
    }
}

function showPrompt(decimals){
    var additional="";
    if(decimals){
        additional=", με προσέγγιση δύο δεκαδικών ψηφίων,";
    }
    var msg="Γράψτε"+additional+" την τιμή που δίνει η ακόλουθη έκφραση.";
    $("#prompt").html(msg);
}